import { CoreStitchUser, StitchCredential, StitchUserIdentity, StitchUserProfile } from "mongodb-stitch-core-sdk";
import StitchRedirectCredential from "./providers/StitchRedirectCredential";
export default interface StitchUser extends CoreStitchUser {
    readonly id: string;
    readonly lastAuthActivity: Date;
    readonly loggedInProviderType: string;
    readonly loggedInProviderName: string;
    readonly isLoggedIn: boolean;
    readonly userType?: string;
    readonly profile: StitchUserProfile;
    readonly identities: StitchUserIdentity[];
    linkUserWithRedirect(credential: StitchRedirectCredential): Promise<void>;
    linkWithCredential(credential: StitchCredential): Promise<StitchUser>;
}
